; Source created with Parsic Version 3.x

; at              : 13/08/02 12.07.48


; Project File    : c:\PROGRA~1\PARSIC\ALIMEN~1\ELEPOT.PIC

; Project Version : 1.0.43

; Created         : 04/03/01 21.55.00

; Last change     : 11/12/01 23.13.00

	PROCESSOR 16F84

	INCLUDE P16F84.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

S0	= 12	; located in Bank 0, 1
OS1_FD	= 13	; located in Bank 0, 1
ZR1	= 14	; located in Bank 0, 1
ZR1_FD	= 15	; located in Bank 0, 1
OS2_FD	= 16	; located in Bank 0, 1
ZR2	= 17	; located in Bank 0, 1
ZR2_FD	= 18	; located in Bank 0, 1
S1	= 19	; located in Bank 0, 1
SYS_WSAV	= 20	; located in Bank 0, 1
SYS_SSAV	= 21	; located in Bank 0, 1
TR1	= 22	; located in Bank 0, 1
TR1_HI	= 23	; located in Bank 0, 1
TR2	= 24	; located in Bank 0, 1
TR2_HI	= 25	; located in Bank 0, 1
MF1	= 26	; located in Bank 0, 1
MF1_HI	= 27	; located in Bank 0, 1
OS3_FD	= 28	; located in Bank 0, 1
RAM	= 29	; located in Bank 0, 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0
	INCFSZ TR2,F
	GOTO SYS_INT_LABEL_1
	INCF TR2_HI,F

SYS_INT_LABEL_1
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_2
	INCF MF1_HI,F

SYS_INT_LABEL_2

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 15
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'11100000'
	MOVWF TRISB

; init vars


; Clear RAM

	MOVLW 12
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	MOVFW FSR
	SUBLW 80
	BTFSS STATUS,ZERO
	GOTO CR1


	BCF STATUS,RP0	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; One Shot -> OS1
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,0
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S0,0
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF S0,0
	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,0
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; Zhler -> ZR1
;***************************************************

	BTFSS S0,2	; Reset ?
	GOTO LABEL_ZR1_COUNT
	CLRF ZR1
	GOTO LABEL_ZR1_SETOUT

LABEL_ZR1_COUNT

; Test auf positive Flanke

	BTFSC ZR1_FD,0
	GOTO LABEL_ZR1_SETFD
	BTFSS S0,0
	GOTO LABEL_ZR1_SETFD

	INCF ZR1,F

LABEL_ZR1_SETOUT

; Output Q0

	BTFSS ZR1,0
	GOTO LABEL_ZR1_SETOUT0
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,0
	GOTO LABEL_ZR1_SETOUT0_END
LABEL_ZR1_SETOUT0
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,0
LABEL_ZR1_SETOUT0_END

LABEL_ZR1_SETFD

	BTFSS S0,0
	GOTO LABEL_ZR1_SETFD2
	BSF ZR1_FD,0
	GOTO LABEL_ZR1_END
LABEL_ZR1_SETFD2
	BCF ZR1_FD,0
LABEL_ZR1_END

;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW 1
	SUBWF ZR1,W	; F - W -> W

LABEL_IF1_CHECK
	BTFSS STATUS,CARRY	; Test auf -> >
	GOTO LABEL_IF1_FALSE
	BTFSC STATUS,ZERO
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S0,1
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S0,1

LABEL_IF1_EXIT
;***************************************************
; One Shot -> OS2
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,1
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S0,3
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF S0,3
	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,1
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************
; Zhler -> ZR2
;***************************************************

	BTFSS S0,4	; Reset ?
	GOTO LABEL_ZR2_COUNT
	CLRF ZR2
	GOTO LABEL_ZR2_SETOUT

LABEL_ZR2_COUNT

; Test auf positive Flanke

	BTFSC ZR2_FD,0
	GOTO LABEL_ZR2_SETFD
	BTFSS S0,3
	GOTO LABEL_ZR2_SETFD

	INCF ZR2,F

LABEL_ZR2_SETOUT

; Output Q0

	BTFSS ZR2,0
	GOTO LABEL_ZR2_SETOUT0
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,1
	GOTO LABEL_ZR2_SETOUT0_END
LABEL_ZR2_SETOUT0
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,1
LABEL_ZR2_SETOUT0_END

; Output Q1

	BTFSS ZR2,1
	GOTO LABEL_ZR2_SETOUT1
	BSF PORTB,2
	GOTO LABEL_ZR2_SETOUT1_END
LABEL_ZR2_SETOUT1
	BCF PORTB,2
LABEL_ZR2_SETOUT1_END

LABEL_ZR2_SETFD

	BTFSS S0,3
	GOTO LABEL_ZR2_SETFD2
	BSF ZR2_FD,0
	GOTO LABEL_ZR2_END
LABEL_ZR2_SETFD2
	BCF ZR2_FD,0
LABEL_ZR2_END

;***************************************************
; Vergleich -> IF2
;***************************************************

	MOVLW 3
	SUBWF ZR2,W	; F - W -> W

LABEL_IF2_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF2_FALSE

LABEL_IF2_TRUE
	BSF S0,4
	GOTO LABEL_IF2_EXIT

LABEL_IF2_FALSE
	BCF S0,4

LABEL_IF2_EXIT
;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,2
	GOTO LABEL_RS1_RESET
	BTFSS PORTA,3
	GOTO LABEL_RS1_ENDE
	BSF PORTB,4	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,4	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSS S0,6
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSS S0,5
	GOTO LABEL_LG1_FALSE
LABEL_LG1_3
	BTFSC S0,7
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF S1,1
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF S1,1
LABEL_LG1_ENDE
;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 3	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 209
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 3	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 209
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,6
	GOTO LABEL_TR1_CLR
	BSF S0,6
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,6
LABEL_TR1_ENDE

;***************************************************
; ODER - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,3
	GOTO LABEL_LG2_TRUE
LABEL_LG2_2
	BTFSC PORTA,2
	GOTO LABEL_LG2_TRUE

LABEL_LG2_FALSE
	BCF S0,5
	GOTO LABEL_LG2_ENDE
LABEL_LG2_TRUE
	BSF S0,5
LABEL_LG2_ENDE
;***************************************************
; Timer -> TR2
;***************************************************

	MOVLW 0	; Test auf >=
	SUBWF TR2_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR2_CHECK
	MOVLW 195
	SUBWF TR2,W	;F-W -> W
LABEL_TR2_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR2_ENDE

LABEL_TR2_RESET
	MOVLW 0	; Test auf >=
	SUBWF TR2_HI,F	;F-W -> F
	MOVLW 195
	SUBWF TR2,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR2_HI,F

LABEL_TR2_SET	; toggel output
	BTFSC S1,0
	GOTO LABEL_TR2_CLR
	BSF S1,0
	GOTO LABEL_TR2_ENDE
LABEL_TR2_CLR
	BCF S1,0
LABEL_TR2_ENDE

;***************************************************
; Anzug-Verzgerung -> MF1
;***************************************************

	BTFSC S0,5	; Eingang auf High ?
	GOTO LABEL_MF1_CHKTIME	; Ja

; RESET

	CLRF MF1
	CLRF MF1_HI
	BCF S0,7
	GOTO LABEL_MF1_EXIT	; raus

LABEL_MF1_CHKTIME

	BTFSC S0,7	; Ausgang schon auf High ?
	GOTO LABEL_MF1_EXIT	; Ja

	MOVLW 45
	SUBWF MF1_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	MOVLW 199
	SUBWF MF1,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	BSF S0,7
LABEL_MF1_EXIT

;***************************************************
; UND - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BTFSS S0,7
	GOTO LABEL_LG3_FALSE
LABEL_LG3_2
	BTFSS S1,0
	GOTO LABEL_LG3_FALSE

LABEL_LG3_TRUE
	BSF S1,2
	GOTO LABEL_LG3_ENDE
LABEL_LG3_FALSE
	BCF S1,2
LABEL_LG3_ENDE
;***************************************************
; ODER - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSC S1,1
	GOTO LABEL_LG4_TRUE
LABEL_LG4_2
	BTFSC S1,2
	GOTO LABEL_LG4_TRUE
	BCF STATUS,RP0	; Bank 0

LABEL_LG4_FALSE
	BCF PORTB,3
	GOTO LABEL_LG4_ENDE
LABEL_LG4_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,3
LABEL_LG4_ENDE
;***************************************************
; RS-FLIP-FLOP -> RS2
;***************************************************

	BTFSC S0,2
	GOTO LABEL_RS2_RESET
	BTFSS PORTB,0
	GOTO LABEL_RS2_ENDE
	BSF PORTB,0	; Ausgang setzen
	GOTO LABEL_RS2_ENDE
LABEL_RS2_RESET
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,0	; Ausgang zurcksetzen
LABEL_RS2_ENDE

;***************************************************
; One Shot -> OS3
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BTFSS PORTB,0
	GOTO LABEL_OS3_1
	BTFSC OS3_FD,0
	GOTO LABEL_OS3_1
	BSF OS3_FD,0
	BSF PORTB,0
	GOTO LABEL_OS3_2
LABEL_OS3_1
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,0
	BTFSC PORTB,0
	GOTO LABEL_OS3_2
	BCF OS3_FD,0
LABEL_OS3_2
;***************************************************
; ODER - Gatter -> LG5
;***************************************************

LABEL_LG5_1
	BTFSC S0,1
	GOTO LABEL_LG5_TRUE
LABEL_LG5_2
	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,4
	GOTO LABEL_LG5_TRUE

LABEL_LG5_FALSE
	BCF S0,2
	GOTO LABEL_LG5_ENDE
LABEL_LG5_TRUE
	BSF S0,2
LABEL_LG5_ENDE
;****************************************

	GOTO MAIN


	END

